% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %                                                                       %
% %    Matlab script for homework of lecture                              %
% %    "Matrix calculus – an introduction using Matlab"                   %
% %    by Christian Rummel                                                %
% %                                                                       %
% %    BENESCO lecture series                                             %
% %    "Signal Analysis and Brain Oscillations in Health and Disease"     %
% %    Bern, 2017/09/29                                                   %
% %                                                                       %
% %    Script demonstrates code vectorization in Matlab at the example    %
% %    of matrix thresholding.                                            %
% %    The student is supposed to play with the matrix dimensions.        %
% %    Mind to stay below 10000 in both dimensions!                       %
% %                                                                       %
% %    written by C. Rummel, 2017/09/25                                   %
% %                                                                       %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dim1   = 500;
dim2   = 200;

thresh =   1;

% 1) generate random matrix

A = randn(dim1,dim2);

% 2) use loops

A1 = A;

tic;
for i1 = 1:dim1
    for i2 = 1:dim2
        if abs(A1(i1,i2))<thresh
            A1(i1,i2) = 0;
        end
    end
end
toc

% 3) avoid loops

A2 = A;

tic;
A2(abs(A2)<thresh) = 0;
toc

% 4) display matrices

figure
subplot(1,3,1);
imagesc(A,[-3 3]);
subplot(1,3,2);
imagesc(A1,[-3 3]);
subplot(1,3,3);
imagesc(A2,[-3 3]);



